Subject: bug#52569: 29.0.50; Wishlist: There should be a way for packages to handle files without reading them in first

From: Lars Ingebrigtsen <[email-masked]>
Date: Mon, 20 Dec 2021 10:53:54 +0100

Juri Linkov <[email-masked]> writes:

>> This would be useful for large files like .sqlite and images.
>
> I'm not sure about images since some image formats are editable,
> like .svg, .xpm, .ps...

I think we'd want to keep the traditinal auto-mode-alist for the
editable image formats.

> Only .pdf with in doc-view-mode could have this optimization of not
> loading the whole file.  Also archive files could benefit from this
> optimization.

arc-mode interprets zip files etc by itself, so I think that would be a
bigger challenge.

>> This function would be called with the file name and would be
>> responsible for returning a buffer that "displays" the file in some
>> sense.
>
> Or when it returns t, this could mean that the function displayed
> the buffer in some other way, for example, by calling an external command.
>
> Then find-file-alist could be used to implement a smarter
> dired-guess-shell-alist like for https://debbugs.gnu.org/18132#92
> So not only files visited by dired will be redirected
> to an external command, but also files visited by C-x C-f.

Hm...   interesting idea...  I think I'll have to ponder that more,
because that'd be a real user interface change, while the thing I was
thinking of here wouldn't be very apparent to the user at all -- it'd
just make things faster.

>> There's some details that aren't clear.  Should this new buffer be
>> visiting the file?  That sounds dangerous, because saving the buffer
>> contents to the file would destroy the file.  But that could be handled
>> by...  write-file-functions?
>
> Also functions that ask about saving a modified file buffer should
> probably skip such buffers.

Yes, probably.

> non-persistent-file-mode, or transient-file-mode, or ephemeral-mode...

Hm...  if `view-mode' wasn't taken already, perhaps that would have been
an option.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no